#include "CJulianDate.h"
#include <cstdio>
#include <iostream> //iostream ergänzt
#include <iomanip>

using namespace std;

//===============================================
// Ergänzen Sie Ihren Code am Ende dieser Datei!
//===============================================

CJulianDate::CJulianDate(long date) {
	m_days = date;
}

CJulianDate::CJulianDate(int year, short month, short day) {
	fromGregorianDate(year, month, day);
}

long CJulianDate::getJulianDate() const {
	return m_days;
}

void CJulianDate::setJulianDate(long date) {
	m_days = date;
}

void CJulianDate::toGregorianDate(int& year, short & month, short & day) const {
	long i, j, k, l, n;

	l = m_days + 68569;
	n = 4 * l / 146097;
	l = l - (146097 * n + 3) / 4;
	i = 4000 * (l + 1) / 1461001;
	l = l - 1461 * i / 4 + 31;
	j = 80 * l / 2447;
	k = l - 2447 * j / 80;
	l = j / 11;
	j = j + 2 - 12 * l;
	i = 100 * (n - 49) + i + l;

	year = i;
	month = j;
	day = k;
}

void CJulianDate::fromGregorianDate(int year, short month, short day) {
	m_days = day - 32075 + 1461 * (year + 4800 + (month - 14) / 12) / 4
			+ 367 * (month - 2 - (month - 14) / 12 * 12) / 12
			- 3 * ((year + 4900 + (month - 14) / 12) / 100) / 4;
}

int CJulianDate::dayOfWeek() const {
	return (m_days % 7) + 1;
}

std::string CJulianDate::dayOfWeekAsName() const {
	switch (dayOfWeek()) {
	case 1:
		return "Montag";
	case 2:
		return "Dienstag";
	case 3:
		return "Mittwoch";
	case 4:
		return "Donnerstag";
	case 5:
		return "Freitag";
	case 6:
		return "Samstag";
	case 7:
		return "Sonntag";
	default:
		return "(Fehler)";
	}
}

std::string CJulianDate::formatDayNumber(short day) const {
	char buffer[5];
	int year;
	short month;
	short refDay;

	toGregorianDate(year, month, refDay);
	sprintf(buffer, day == refDay ? "[%2d]" : " %2d ", day);
	return std::string(buffer);
}

bool CJulianDate::operator <(const CJulianDate& rhs) const {
	return m_days < rhs.m_days;
}

//=====================================================
// Ergänzen Sie Ihren Code unterhalb dieses Kommentars
//=====================================================

std::ostream& operator << (std::ostream& lop, const CJulianDate& rhs){
	short day, month;
	int year;
	rhs.toGregorianDate(year, month, day);
	lop<< rhs.dayOfWeekAsName() << ", " << day << "." << month << "." << year << std::endl;
	return lop;
}

void CJulianDate::prettyPrintMonth() {
	short day, month;
	int year;
	this->toGregorianDate(year, month, day);
	cout << " Mo Di Mi Do Fr Sa So" << endl;
	CJulianDate copyDate = CJulianDate(year, month, 1);
	int dayOfWeek = copyDate.dayOfWeek();
	cout << string(3*dayOfWeek-3, ' ');
	for (int printDay = 1; ; printDay++) {
		if (printDay == day)
			cout << "[" << setw(2) << printDay;
		else if (printDay == day + 1)
			cout << "]" << setw(2) << printDay;
		else
			cout << setw(3) << printDay;
		copyDate += 1;
		short copyDay, copyMonth;
		int copyYear;
		copyDate.toGregorianDate(copyYear, copyMonth, copyDay);
		if (copyDay == 1) break;
		if (copyDate.dayOfWeek() == 1) cout << endl;
	
	}
	cout << endl;
}
